* PAUSE
*
* pjwitte 2o24+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS Version JS+ only! (and Minerva and SMSQ/E)
*


	section code

	xdef	pause

	xref	chan_d6

	include dev8_keys_qdos_io
	include dev8_keys_qlv
	include dev8_keys_err

*
pause
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Enhanced PAUSE for Qdos (JS+), for added compatibility with Minerva and
* SMSQ/E programs.
*
* PAUSE[#channel] [, timeout]
*

	moveq #0,d6		default channel = 0
	bsr chan_d6
	bne.s ok		no channel, simply return

	moveq #-1,d5		default timeout

	move.w sb.gtint,a2	get integer
	jsr (a2)
	bne.s exit		 oops!

	subq.w #1,d3		we only want one more..
	bgt.s err_bp		 oops: too many!
	bne.s skip		 none is ok

	move.w (a6,a1.l),d5	timeout as per parameter
	bge.s skip		+ve is ok

	moveq #1,d4		only negative value
	add.l d5,d4		 -1 allowed
	bne.s err_bp		 anything else is baad

skip
	move.w d5,d3		set timeout
	moveq #iob.fbyt,d0	fetch byte
	trap #do.io

ok
	moveq #0,d0

exit
	rts

err_bp
	moveq #err.ipar,d0
	rts

*
	end
